// Zero page variables
// *******************
.const	result	=	$fa
.const	ptr		=	$fb
.const	tmp		=	$fd
.const	old		=	$02

// Special constants
// *****************
.const	special	=	106
.const	bgcolor	=	BLACK
.const	fgcolor	=	WHITE

// Absolute addresses
// ******************
.const	video		=	$2000	// 2000 aligned!
.const	convtable	=	$8000	// Aligned! 10 bit => 8 bit conversion table
.const	row			=	$8400	// Buffer row
.const	screen		=	$0c00

.pc = $0326	

.byte <start,>start
.byte $ed,$f6

start:	
	// Init VIC

	lda #$81
    sta $d40f
    sta $d412
	lda #$3b	
	sta $d011	
	sta $d018
	lda #bgcolor	
	sta $d020
	
	// Init screen and random stuff
	
	ldy #$00
!:
	lda #[[fgcolor*$10]+bgcolor]	// Clear screen
	sta screen+$0000,y
	sta screen+$0100,y
	sta screen+$0200,y
	sta screen+$0300,y
	lda $d41b				// Init "Random" row
	sta row,y
	dey
	bne !-
	sty row+41				// Right border => 0
		
	// Init tables

createTable:		
	sty ptr					// Low byte is 0
	lda #>convtable
	sta	ptr+1
extloop:	
	lda ptr+1
	sta tmp+1	
	sty tmp
	lda #$80	
	sta result
inloop:
	lda tmp
	and #$07
	tax	
specialpointer:
	lda #special
!:
	lsr 
	dex
	bpl !-
	php
	lsr tmp+1
	ror tmp	
	plp
	ror result
	bcc inloop
	lda result
	sta (ptr),y	
	iny
	bne extloop
	inc ptr+1
	lda ptr+1
	and #$03
	bne extloop
		
	// Drawing routine

drawing:	
	sta ptr			// 0
	lda #>video
	sta ptr+1
	
extmainloop:	
	ldx #40		
	stx old
	
mainloop:	
	lda old
	and #$01
	ora #[>convtable]/2
	sta tmp+1

	lda row,x
	asl
	lda row+1,x	
	sta old
	rol
	sta tmp	
	rol tmp+1			// Carry cleared for free
	lda (tmp),y	
	sta (ptr),y
	sta row+1,x
	lda ptr
	adc #$08
	sta ptr
	bcc skip
	inc ptr+1
skip:
	dex	
	bne mainloop	
	
	ldx #$07
	axs #$00
	cpx #$07
	bcs !+	
	sbc #[<318]
	sta ptr
	lda ptr+1
	sbc #[>318]
	sta ptr+1	
	bcs extmainloop
!:
	and #$f8
	sta ptr
	lda ptr+1
	and #$20	
	bne extmainloop	
	jmp drawing
	
	
	